TanStack
Guides

Custom plugins

TanStack devtools allows you to create your own custom plugins by emitting and listening to our event bus.

Prerequisite

This guide will walk you through a simple example where our library is a counter with a count history. A working example can be found in our custom-plugin example.

This is our library code:

counter.ts

tsx
export function createCounter() {
  let count = 0
  const history = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)
    },
    decrement: () => {
      count--
      history.push(count)
    },
  };
}

Event Client Setup

Install the TanStack Devtools Event Client utils.

shell
npm i @tanstack/devtools-event-client

First you will need to setup the EventClient.

eventClient.ts

tsx
import { EventClient } from '@tanstack/devtools-event-client'


type EventMap = {
  // The key is the event suffix only — the pluginId is prepended automatically by EventClient
  // The value is the expected type of the event payload
  'counter-state': { count: number, history: number[] }
}

class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      // The pluginId is prepended to event map keys when emitting/listening
      pluginId: 'custom-devtools',
    })
  }
}

// This is where the magic happens, it'll be used throughout your application.
export const DevtoolsEventClient = new CustomEventClient()

Event Client Integration

Now we need to hook our EventClient into the application code. This can be done in many way's, a useEffect that emits the current state, or a subscription to an observer, all that matters is that when you want to emit the current state you do the following.

Our new library code will looks as follows:

counter.ts

tsx
import { DevtoolsEventClient } from './eventClient.ts'

export function createCounter() {
  let count = 0
  const history: Array<number> = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)

      // The emit eventSuffix must match that of the EventMap defined in eventClient.ts
      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
    decrement: () => {
      count--
      history.push(count)

      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
  }
}

Important

EventClient is framework agnostic so this process will be the same regardless of framework or even in vanilla JavaScript.

Consuming The Event Client

Now we need to create our devtools panel, for a simple approach write the devtools in the framework that the adapter is, be aware that this will make the plugin framework specific.

Because TanStack is framework agnostic we have taken a more complicated approach that will be explained in coming docs (if framework agnosticism is not a concern to you, you can ignore this).

DevtoolPanel.tsx

tsx
import { createSignal, onCleanup } from 'solid-js'
import { DevtoolsEventClient } from './eventClient'

export function DevtoolPanel() {
  const [state, setState] = createSignal<{ count: number; history: number[] }>()

  const cleanup = DevtoolsEventClient.on('counter-state', (e) => setState(e.payload))
  onCleanup(cleanup)

  return (
    <div>
      <div>{state()?.count}</div>
      <div>{JSON.stringify(state()?.history)}</div>
    </div>
  )
}

Application Integration

This step follows what's shown in basic-setup for a more documented guide go check it out.

index.tsx

tsx
import { render } from 'solid-js/web'
import { TanStackDevtools } from '@tanstack/solid-devtools'
import { DevtoolPanel } from './DevtoolPanel'

render(() => (
  <>
    <App />
    <TanStackDevtools
      plugins={[
        {
          name: 'Custom devtools',
          render: () => <DevtoolPanel />,
        },
      ]}
    />
  </>
), document.getElementById('root')!)

Debugging

Both the TanStackDevtools component and the TanStack EventClient come with built in debug mode which will log to the console the emitted event as well as the EventClient status.

TanStackDevtool's debugging mode can be activated like so:

tsx
<TanStackDevtools
  eventBusConfig={{ debug: true }}
  plugins={[
    {
      name: 'Custom devtools',
      render: () => <DevtoolPanel />,
    },
  ]}
/>

Where as the EventClient's debug mode can be activated by:

tsx
class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      pluginId: 'custom-devtools',
      debug: true,
    })
  }
}

Activating the debug mode will log to the console the current events that emitter has emitted or listened to. The EventClient will have appended [tanstack-devtools:${pluginId}] and the client will have appended [tanstack-devtools:client-bus].

Heres an example of both:

plaintext
[tanstack-devtools:client-bus] Initializing client event bus

[tanstack-devtools:custom-devtools-plugin] Registered event to bus custom-devtools:counter-state

Production builds

By default the root import of @tanstack/devtools-event-client no-ops outside development. When your bundler sets process.env.NODE_ENV to anything other than 'development', the real client is replaced by a no-op and tree-shaken out of your production bundle:

ts
// dev: real client — production: no-op (tree-shaken away)
import { EventClient } from '@tanstack/devtools-event-client'

If you are an open-source author who deliberately wants devtools events in production, import the real client from the /production subpath instead. It is never stripped:

ts
// always the real client, in every environment
import { EventClient } from '@tanstack/devtools-event-client/production'

The public API is identical between the two imports — only the production runtime behavior differs.

TanStack
Guides

Custom plugins

TanStack devtools allows you to create your own custom plugins by emitting and listening to our event bus.

Prerequisite

This guide will walk you through a simple example where our library is a counter with a count history. A working example can be found in our custom-plugin example.

This is our library code:

counter.ts

tsx
export function createCounter() {
  let count = 0
  const history = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)
    },
    decrement: () => {
      count--
      history.push(count)
    },
  };
}

Event Client Setup

Install the TanStack Devtools Event Client utils.

shell
npm i @tanstack/devtools-event-client

First you will need to setup the EventClient.

eventClient.ts

tsx
import { EventClient } from '@tanstack/devtools-event-client'


type EventMap = {
  // The key is the event suffix only — the pluginId is prepended automatically by EventClient
  // The value is the expected type of the event payload
  'counter-state': { count: number, history: number[] }
}

class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      // The pluginId is prepended to event map keys when emitting/listening
      pluginId: 'custom-devtools',
    })
  }
}

// This is where the magic happens, it'll be used throughout your application.
export const DevtoolsEventClient = new CustomEventClient()

Event Client Integration

Now we need to hook our EventClient into the application code. This can be done in many way's, a useEffect that emits the current state, or a subscription to an observer, all that matters is that when you want to emit the current state you do the following.

Our new library code will looks as follows:

counter.ts

tsx
import { DevtoolsEventClient } from './eventClient.ts'

export function createCounter() {
  let count = 0
  const history: Array<number> = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)

      // The emit eventSuffix must match that of the EventMap defined in eventClient.ts
      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
    decrement: () => {
      count--
      history.push(count)

      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
  }
}

Important

EventClient is framework agnostic so this process will be the same regardless of framework or even in vanilla JavaScript.

Consuming The Event Client

Now we need to create our devtools panel. For Angular, create a standalone component that listens to events from the EventClient.

DevtoolPanel.ts

ts
import { Component, OnDestroy, OnInit, signal } from '@angular/core'
import { DevtoolsEventClient } from './eventClient'

@Component({
  selector: 'devtool-panel',
  standalone: true,
  template: `
    <div>
      <div>{{ state()?.count }}</div>
      <div>{{ stateHistory() }}</div>
    </div>
  `,
})
export class DevtoolPanel implements OnInit, OnDestroy {
  state = signal<{ count: number; history: number[] } | undefined>(undefined)
  private cleanup?: () => void

  get stateHistory() {
    return JSON.stringify(this.state()?.history)
  }

  ngOnInit() {
    this.cleanup = DevtoolsEventClient.on('counter-state', (e) => {
      this.state.set(e.payload)
    })
  }

  ngOnDestroy() {
    this.cleanup?.()
  }
}

Application Integration

This step follows what's shown in basic-setup for a more documented guide go check it out.

app.component.ts

ts
import { Component } from '@angular/core'
import { TanStackDevtools } from '@tanstack/angular-devtools'
import type { TanStackDevtoolsAngularPlugin } from '@tanstack/angular-devtools'
import { DevtoolPanelComponent } from './devtool-panel.component'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackDevtools],
  template: `
    <app-content />
    <tanstack-devtools [plugins]="plugins" />
  `,
})
export class AppComponent {
  plugins: Array<TanStackDevtoolsAngularPlugin> = [
    { name: 'Custom devtools', component: DevtoolPanel },
  ]
}

Debugging

Both the TanStackDevtools and the TanStack EventClient come with built in debug mode which will log to the console the emitted event as well as the EventClient status.

TanStackDevtools debugging mode can be activated like so:

ts
@Component({
  template: `
    <tanstack-devtools
      [eventBusConfig]="{ debug: true }"
      [plugins]="plugins"
    />
  `,
  imports: [TanStackDevtoolsComponent],
})
export class App {
  plugins: Array<TanStackDevtoolsAngularPlugin> = [
    { name: 'Custom devtools', component: DevtoolPanel },
  ]
}

Where as the EventClient's debug mode can be activated by:

tsx
class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      pluginId: 'custom-devtools',
      debug: true,
    })
  }
}

Activating the debug mode will log to the console the current events that emitter has emitted or listened to. The EventClient will have appended [tanstack-devtools:${pluginId}] and the client will have appended [tanstack-devtools:client-bus].

Heres an example of both:

plaintext
[tanstack-devtools:client-bus] Initializing client event bus

[tanstack-devtools:custom-devtools-plugin] Registered event to bus custom-devtools:counter-state

Production builds

By default the root import of @tanstack/devtools-event-client no-ops outside development. When your bundler sets process.env.NODE_ENV to anything other than 'development', the real client is replaced by a no-op and tree-shaken out of your production bundle:

ts
// dev: real client — production: no-op (tree-shaken away)
import { EventClient } from '@tanstack/devtools-event-client'

If you are an open-source author who deliberately wants devtools events in production, import the real client from the /production subpath instead. It is never stripped:

ts
// always the real client, in every environment
import { EventClient } from '@tanstack/devtools-event-client/production'

The public API is identical between the two imports — only the production runtime behavior differs.

TanStack
Guides

Custom plugins

TanStack devtools allows you to create your own custom plugins by emitting and listening to our event bus.

Prerequisite

This guide will walk you through a simple example where our library is a counter with a count history. A working example can be found in our custom-plugin example.

This is our library code:

counter.ts

tsx
export function createCounter() {
  let count = 0
  const history = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)
    },
    decrement: () => {
      count--
      history.push(count)
    },
  };
}

Event Client Setup

Install the TanStack Devtools Event Client utils.

shell
npm i @tanstack/devtools-event-client

First you will need to setup the EventClient.

eventClient.ts

tsx
import { EventClient } from '@tanstack/devtools-event-client'


type EventMap = {
  // The key is the event suffix only — the pluginId is prepended automatically by EventClient
  // The value is the expected type of the event payload
  'counter-state': { count: number, history: number[] }
}

class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      // The pluginId is prepended to event map keys when emitting/listening
      pluginId: 'custom-devtools',
    })
  }
}

// This is where the magic happens, it'll be used throughout your application.
export const DevtoolsEventClient = new CustomEventClient()

Event Client Integration

Now we need to hook our EventClient into the application code. This can be done in many way's, a useEffect that emits the current state, or a subscription to an observer, all that matters is that when you want to emit the current state you do the following.

Our new library code will looks as follows:

counter.ts

tsx
import { DevtoolsEventClient } from './eventClient.ts'

export function createCounter() {
  let count = 0
  const history: Array<number> = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)

      // The emit eventSuffix must match that of the EventMap defined in eventClient.ts
      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
    decrement: () => {
      count--
      history.push(count)

      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
  }
}

Important

EventClient is framework agnostic so this process will be the same regardless of framework or even in vanilla JavaScript.

Consuming The Event Client

Now we need to create our devtools panel. For Svelte, create a component that listens to events from the EventClient using Svelte 5 runes.

DevtoolPanel.svelte

svelte
<script lang="ts">
  import { onMount, onDestroy } from 'svelte'
  import { DevtoolsEventClient } from './eventClient'

  let state = $state<{ count: number; history: number[] } | undefined>(undefined)
  let cleanup: (() => void) | undefined

  onMount(() => {
    cleanup = DevtoolsEventClient.on('counter-state', (e) => {
      state = e.payload
    })
  })

  onDestroy(() => {
    cleanup?.()
  })
</script>

<div>
  <div>{state?.count}</div>
  <div>{JSON.stringify(state?.history)}</div>
</div>

Application Integration

This step follows what's shown in basic-setup for a more documented guide go check it out.

App.svelte

svelte
<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import type { TanStackDevtoolsSveltePlugin } from '@tanstack/svelte-devtools'
  import DevtoolPanel from './DevtoolPanel.svelte'

  const plugins: TanStackDevtoolsSveltePlugin[] = [
    { name: 'Custom devtools', component: DevtoolPanel },
  ]
</script>

<main>
  <!-- Your app content -->
</main>
<TanStackDevtools {plugins} />

Debugging

Both the TanStackDevtools component and the TanStack EventClient come with built in debug mode which will log to the console the emitted event as well as the EventClient status.

TanStackDevtools debugging mode can be activated like so:

svelte
<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import type { TanStackDevtoolsSveltePlugin } from '@tanstack/svelte-devtools'
  import DevtoolPanel from './DevtoolPanel.svelte'

  const plugins: TanStackDevtoolsSveltePlugin[] = [
    { name: 'Custom devtools', component: DevtoolPanel },
  ]
</script>

<TanStackDevtools
  eventBusConfig={{ debug: true }}
  {plugins}
/>

Where as the EventClient's debug mode can be activated by:

tsx
class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      pluginId: 'custom-devtools',
      debug: true,
    })
  }
}

Activating the debug mode will log to the console the current events that emitter has emitted or listened to. The EventClient will have appended [tanstack-devtools:${pluginId}] and the client will have appended [tanstack-devtools:client-bus].

Heres an example of both:

plaintext
[tanstack-devtools:client-bus] Initializing client event bus

[tanstack-devtools:custom-devtools-plugin] Registered event to bus custom-devtools:counter-state

TanStack
Guides

Custom plugins

TanStack devtools allows you to create your own custom plugins by emitting and listening to our event bus.

Prerequisite

This guide will walk you through a simple example where our library is a counter with a count history. A working example can be found in our custom-plugin example.

This is our library code:

counter.ts

tsx
export function createCounter() {
  let count = 0
  const history = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)
    },
    decrement: () => {
      count--
      history.push(count)
    },
  };
}

Event Client Setup

Install the TanStack Devtools Event Client utils.

shell
npm i @tanstack/devtools-event-client

First you will need to setup the EventClient.

eventClient.ts

tsx
import { EventClient } from '@tanstack/devtools-event-client'


type EventMap = {
  // The key is the event suffix only — the pluginId is prepended automatically by EventClient
  // The value is the expected type of the event payload
  'counter-state': { count: number, history: number[] }
}

class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      // The pluginId is prepended to event map keys when emitting/listening
      pluginId: 'custom-devtools',
    })
  }
}

// This is where the magic happens, it'll be used throughout your application.
export const DevtoolsEventClient = new CustomEventClient()

Event Client Integration

Now we need to hook our EventClient into the application code. This can be done in many way's, a useEffect that emits the current state, or a subscription to an observer, all that matters is that when you want to emit the current state you do the following.

Our new library code will looks as follows:

counter.ts

tsx
import { DevtoolsEventClient } from './eventClient.ts'

export function createCounter() {
  let count = 0
  const history: Array<number> = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)

      // The emit eventSuffix must match that of the EventMap defined in eventClient.ts
      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
    decrement: () => {
      count--
      history.push(count)

      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
  }
}

Important

EventClient is framework agnostic so this process will be the same regardless of framework or even in vanilla JavaScript.

Consuming The Event Client

Now we need to create our devtools panel, for a simple approach write the devtools in the framework that the adapter is, be aware that this will make the plugin framework specific.

Because TanStack is framework agnostic we have taken a more complicated approach that will be explained in coming docs (if framework agnosticism is not a concern to you, you can ignore this).

DevtoolPanel.vue

vue
<script setup lang="ts">
import { ref, onMounted, onUnmounted } from 'vue'
import { DevtoolsEventClient } from './eventClient'

const state = ref<{ count: number; history: number[] }>()

let cleanup: (() => void) | undefined

onMounted(() => {
  cleanup = DevtoolsEventClient.on('counter-state', (e) => {
    state.value = e.payload
  })
})

onUnmounted(() => {
  cleanup?.()
})
</script>

<template>
  <div>
    <div>{{ state?.count }}</div>
    <div>{{ JSON.stringify(state?.history) }}</div>
  </div>
</template>

Application Integration

This step follows what's shown in basic-setup for a more documented guide go check it out.

App.vue

vue
<script setup lang="ts">
import { TanStackDevtools } from '@tanstack/vue-devtools'
import DevtoolPanel from './DevtoolPanel.vue'

const plugins = [
  { name: 'Custom devtools', component: DevtoolPanel },
]
</script>

<template>
  <App />
  <TanStackDevtools :plugins="plugins" />
</template>

Debugging

Both the TanStackDevtools component and the TanStack EventClient come with built in debug mode which will log to the console the emitted event as well as the EventClient status.

TanStackDevtool's debugging mode can be activated like so:

vue
<template>
  <TanStackDevtools
    :event-bus-config="{ debug: true }"
    :plugins="[
      {
        name: 'Custom devtools',
        component: DevtoolPanel,
      },
    ]"
  />
</template>

Where as the EventClient's debug mode can be activated by:

tsx
class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      pluginId: 'custom-devtools',
      debug: true,
    })
  }
}

Activating the debug mode will log to the console the current events that emitter has emitted or listened to. The EventClient will have appended [tanstack-devtools:${pluginId}] and the client will have appended [tanstack-devtools:client-bus].

Heres an example of both:

plaintext
[tanstack-devtools:client-bus] Initializing client event bus

[tanstack-devtools:custom-devtools-plugin] Registered event to bus custom-devtools:counter-state

Production builds

By default the root import of @tanstack/devtools-event-client no-ops outside development. When your bundler sets process.env.NODE_ENV to anything other than 'development', the real client is replaced by a no-op and tree-shaken out of your production bundle:

ts
// dev: real client — production: no-op (tree-shaken away)
import { EventClient } from '@tanstack/devtools-event-client'

If you are an open-source author who deliberately wants devtools events in production, import the real client from the /production subpath instead. It is never stripped:

ts
// always the real client, in every environment
import { EventClient } from '@tanstack/devtools-event-client/production'

The public API is identical between the two imports — only the production runtime behavior differs.

Guides

Custom plugins

TanStack devtools allows you to create your own custom plugins by emitting and listening to our event bus.

Prerequisite

This guide will walk you through a simple example where our library is a counter with a count history. A working example can be found in our custom-plugin example.

This is our library code:

counter.ts

tsx
export function createCounter() {
  let count = 0
  const history = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)
    },
    decrement: () => {
      count--
      history.push(count)
    },
  };
}
export function createCounter() {
  let count = 0
  const history = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)
    },
    decrement: () => {
      count--
      history.push(count)
    },
  };
}

Event Client Setup

Install the TanStack Devtools Event Client utils.

sh
npm i @tanstack/devtools-event-client
npm i @tanstack/devtools-event-client

First you will need to setup the EventClient.

eventClient.ts

tsx
import { EventClient } from '@tanstack/devtools-event-client'


type EventMap = {
  // The key is the event suffix only β€” the pluginId is prepended automatically by EventClient
  // The value is the expected type of the event payload
  'counter-state': { count: number, history: number[] }
}

class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      // The pluginId is prepended to event map keys when emitting/listening
      pluginId: 'custom-devtools',
    })
  }
}

// This is where the magic happens, it'll be used throughout your application.
export const DevtoolsEventClient = new CustomEventClient()
import { EventClient } from '@tanstack/devtools-event-client'


type EventMap = {
  // The key is the event suffix only β€” the pluginId is prepended automatically by EventClient
  // The value is the expected type of the event payload
  'counter-state': { count: number, history: number[] }
}

class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      // The pluginId is prepended to event map keys when emitting/listening
      pluginId: 'custom-devtools',
    })
  }
}

// This is where the magic happens, it'll be used throughout your application.
export const DevtoolsEventClient = new CustomEventClient()

Event Client Integration

Now we need to hook our EventClient into the application code. This can be done in many way's, a useEffect that emits the current state, or a subscription to an observer, all that matters is that when you want to emit the current state you do the following.

Our new library code will looks as follows:

counter.ts

tsx
import { DevtoolsEventClient } from './eventClient.ts'

export function createCounter() {
  let count = 0
  const history: Array<number> = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)

      // The emit eventSuffix must match that of the EventMap defined in eventClient.ts
      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
    decrement: () => {
      count--
      history.push(count)

      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
  }
}
import { DevtoolsEventClient } from './eventClient.ts'

export function createCounter() {
  let count = 0
  const history: Array<number> = []

  return {
    getCount: () => count,
    increment: () => {
      count++
      history.push(count)

      // The emit eventSuffix must match that of the EventMap defined in eventClient.ts
      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
    decrement: () => {
      count--
      history.push(count)

      DevtoolsEventClient.emit('counter-state', {
        count,
        history,
      })
    },
  }
}
Important

EventClient is framework agnostic so this process will be the same regardless of framework or even in vanilla JavaScript.

Consuming The Event Client

Now we need to create our devtools panel, for a simple approach write the devtools in the framework that the adapter is, be aware that this will make the plugin framework specific.

Because TanStack is framework agnostic we have taken a more complicated approach that will be explained in coming docs (if framework agnosticism is not a concern to you, you can ignore this).

DevtoolsPanel.ts

tsx
import { DevtoolsEventClient } from './eventClient.ts'

export function DevtoolPanel() {
  const [state, setState] = useState()

  useEffect(() => {
    // subscribe to the emitted event
    const cleanup = DevtoolsEventClient.on("counter-state", e => setState(e.payload))
    return cleanup
  }, [])

  return (
    <div>
      <div>{state.count}</div>
      <div>{JSON.stringify(state.history)}</div>
    </div>
  )
}
import { DevtoolsEventClient } from './eventClient.ts'

export function DevtoolPanel() {
  const [state, setState] = useState()

  useEffect(() => {
    // subscribe to the emitted event
    const cleanup = DevtoolsEventClient.on("counter-state", e => setState(e.payload))
    return cleanup
  }, [])

  return (
    <div>
      <div>{state.count}</div>
      <div>{JSON.stringify(state.history)}</div>
    </div>
  )
}

Application Integration

This step follows what's shown in basic-setup for a more documented guide go check it out. As well as the complete custom-devtools example in our examples section.

Main.tsx

tsx
import { DevtoolPanel } from './DevtoolPanel'

createRoot(document.getElementById('root')!).render(
  <StrictMode>
    <App />

    <TanStackDevtools
      plugins={[
        {
          // Name it what you like, this is how it will appear in the Menu
          name: 'Custom devtools',
          render: <DevtoolPanel />,
        },
      ]}
    />
  </StrictMode>,
)
import { DevtoolPanel } from './DevtoolPanel'

createRoot(document.getElementById('root')!).render(
  <StrictMode>
    <App />

    <TanStackDevtools
      plugins={[
        {
          // Name it what you like, this is how it will appear in the Menu
          name: 'Custom devtools',
          render: <DevtoolPanel />,
        },
      ]}
    />
  </StrictMode>,
)

Debugging

Both the TanStackDevtools component and the TanStack EventClient come with built in debug mode which will log to the console the emitted event as well as the EventClient status.

TanStackDevtool's debugging mode can be activated like so:

tsx
<TanStackDevtools
  eventBusConfig={{ debug: true }}
  plugins={[
    {
      // call it what you like, this is how it will appear in the Menu
      name: 'Custom devtools',
      render: <DevtoolPanel />,
    },
  ]}
/>
<TanStackDevtools
  eventBusConfig={{ debug: true }}
  plugins={[
    {
      // call it what you like, this is how it will appear in the Menu
      name: 'Custom devtools',
      render: <DevtoolPanel />,
    },
  ]}
/>

Where as the EventClient's debug mode can be activated by:

tsx
class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      pluginId: 'custom-devtools',
      debug: true,
    })
  }
}
class CustomEventClient extends EventClient<EventMap> {
  constructor() {
    super({
      pluginId: 'custom-devtools',
      debug: true,
    })
  }
}

Activating the debug mode will log to the console the current events that emitter has emitted or listened to. The EventClient will have appended [tanstack-devtools:${pluginId}] and the client will have appended [tanstack-devtools:client-bus].

Heres an example of both:

plaintext
🌴 [tanstack-devtools:client-bus] Initializing client event bus

🌴 [tanstack-devtools:custom-devtools-plugin] Registered event to bus custom-devtools:counter-state
🌴 [tanstack-devtools:client-bus] Initializing client event bus

🌴 [tanstack-devtools:custom-devtools-plugin] Registered event to bus custom-devtools:counter-state